/*
 * $Id$
 * 
 * (c)reated: 28-Feb-05 by boehm@javatux.de
 */

package verkehrs;
import java.awt.*;
import java.applet.*;
import java.util.*;
import java.util.Observer;

/**
 * View einer Verkehrsampel
 * 
 * @author <a href="mailto:boehm@javatux.de">oliver </a>
 * @since 28.02.2005
 * @version $revision$
 */
@View
public class AmpelView extends Applet implements Observer {

    private static final long serialVersionUID = 3258125873377786165L;

    //  private attributes
    private AmpelModel model;

    private AmpelController controller;

    private Label label;

    private Panel lightPanel;

    private Panel buttonPanel;

    private Button nextButton;

    private Button stopButton;

    private MyCanvas theCanvas;

    public void init() {

        //  init objects
        model = new AmpelModel();
        controller = new AmpelController(this, model);
        label = new Label("eine Verkehrsampel");
        nextButton = new Button("Next");
        nextButton.addActionListener(controller);
        nextButton.setActionCommand("next");
        stopButton = new Button("Stop");
        stopButton.addActionListener(controller);
        stopButton.setActionCommand("stop");
        theCanvas = new MyCanvas();
        //theCanvas.setSize (100, 260);

        //  layout label
        setLayout(new BorderLayout());
        add(label, "North");

        //  layout traffic light
        lightPanel = new Panel();
        lightPanel.setLayout(new FlowLayout());
        lightPanel.add(theCanvas);
        add(lightPanel, "Center");

        //  layout buttons
        buttonPanel = new Panel();
        buttonPanel.setLayout(new FlowLayout());
        buttonPanel.add(nextButton, "East");
        buttonPanel.add(stopButton, "West");
        add(buttonPanel, "South");

        //  and now... show it
        setVisible(true);
        model.addObserver(this);
    }

    //  paint it
    public void paint() {
        theCanvas.repaint();
    }

    public void paint(Graphics g) {
        theCanvas.paint(g);
    }

    public void update(Observable o, Object arg) {
        paint();
    }
    
    /**
     * Only needed for testing...
     * @return
     */
    public AmpelModel getAmpelModel() {
        return this.model;
    }

    //  inner class
    private class MyCanvas extends Canvas {

        private static final long serialVersionUID = 3978985483395085616L;

        public MyCanvas() {
            super();
            setSize(100, 260);
        }

        public Dimension getMinimumSize() {
            return new Dimension(100, 260);
        }

        public void paint(Graphics g) {
            switch (model.getState()) {
            case AmpelModel.RED:
                paintLights(g, true, false, false);
                break;
            case AmpelModel.RED_YELLOW:
                paintLights(g, true, true, false);
                break;
            case AmpelModel.GREEN:
                paintLights(g, false, false, true);
                break;
            case AmpelModel.YELLOW:
                paintLights(g, false, true, false);
                break;
            }
        }

        private void paintLights(Graphics g, boolean red, boolean yellow,
                boolean green) {
            g.setColor(Color.black);
            g.fillRect(10, 10, 80, 240);
            if (red) {
                g.setColor(Color.red);
                g.fillOval(20, 20, 60, 60);
            }
            if (yellow) {
                g.setColor(Color.yellow);
                g.fillOval(20, 100, 60, 60);
            }
            if (green) {
                g.setColor(Color.green);
                g.fillOval(20, 180, 60, 60);
            }
        }
    }
    //  end of inner class

}