/*
 * Created on 28.02.2005
 *
 * $Id$
 */
package verkehrs.test;

import java.lang.reflect.Method;
import java.util.*;

import junit.framework.TestCase;
import verkehrs.*;

public class AmpelModelTest extends TestCase implements Observer {
    
    private AmpelModel model;

    public static void main(String[] args) {
        junit.textui.TestRunner.run(AmpelModelTest.class);
    }

    protected void setUp() throws Exception {
        model = new AmpelModel();
    }

    public final void testReset() {
        model.reset();
        int state = model.getState();
        model.nextState();
        model.reset();
        assertEquals(state, model.getState());
    }

    public final void testGetState() {
        int state = model.getState();
        assertTrue((state == AmpelModel.GREEN) || (state == AmpelModel.RED)
                || (state == AmpelModel.RED_YELLOW)
                || (state == AmpelModel.YELLOW));
    }
    
    public final void testSetChanged() throws SecurityException, NoSuchMethodException {
        Method m = AmpelModel.class.getMethod("setChanged", (Class[]) null);
        assertNotNull(m);
    }
    
    public final void testNotifyObservers() {
        model.addObserver(this);
        model.nextState();
        assertTrue(notified);
    }

    
    
    //  Observer-Methoden
    
    private boolean notified = false;
    
    public void update(Observable observed, Object arg) {
        notified = true;
    }
}
