/*
 * Created on 06.01.2005
 *
 * $Id$
 */
package casino.log;


import org.aspectj.lang.*;
import org.aspectj.lang.reflect.*;

//import org.apache.log4j.*;
import org.apache.commons.logging.*;
import casino.*;            // wichtig, sonst kennt er 'Einsatz' nicht
import casino.player.*;


/**
 * Big Brother is watching you...
 * 
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 06.01.2005
 * @version $revision$
 */
public aspect PlayerLogging extends AbstractLoggingAspect {

    /*
     * do Logging
     */
    
    //private static Logger log = Logger.getLogger(PlayerLogging.class);
    private static Log log = LogFactory.getLog(PlayerLogging.class);

    /**
     * Gibt den Logger fuer diesen Aspekt zurueck.
     */
    public Log getLogger() {
        return log;
    }
    
    /** der Einsatz alle RoulettePlayer-Kassen wird damit ueberwacht */
    pointcut logPoints(Object x) : 
        execution(public Einsatz RoulettePlayer+.getEinsatz())
        && this(x);
    
    
    
    /**
     * Wann wird die Player-Klasse initialisiert?
     */
    after() : staticinitialization(RoulettePlayer+) {
        logJoinPoint(thisJoinPoint);
    }
    
    /**
     * Wann wird der Spieler initialisiert?
     */
    after() : initialization(RoulettePlayer+.new(..)) {
        logJoinPoint(thisJoinPoint);
    }
    
    /**
     * Wann findet die Vorinitialisierung statt?
     */
    after() : preinitialization(RoulettePlayer+.new(..)) {
        logJoinPoint(thisJoinPoint);
    }
    
    /**
     * Alles wichtig zum uebergebenen Joinpoint auseben.
     */
    private void logJoinPoint(JoinPoint joinpoint) {
        SourceLocation loc = joinpoint.getSourceLocation();
        log.debug("" + loc + " - " + joinpoint.toShortString());
    }
    
}
