/*
 * Created on 06.01.2005
 *
 * $Id$
 */
package casino.log;

//import org.apache.log4j.*;
import org.apache.commons.logging.*;


/**
 * Dieser Aspekt uebernimmt das Logging.
 * 
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 06.01.2005
 * @version $revision$
 */
public abstract aspect AbstractLoggingAspect {

    /** welcher Logger soll verwendet werden? */
    //public abstract Logger getLogger();
    public abstract Log getLogger();
   
    /** die abgeleiteten Aspekte definieren, was geloggt werden soll. */
    abstract pointcut logPoints(Object x);
    
    /**
     * Gibt den Joinpoint in Kurzform aus. Zusaetzlich wird das Ergebnis der
     * Methode, der Rueckgabewert, ausgegeben.
     */
    after(Object x) returning(Object r): logPoints(x) {
        getLogger().info(x + ": " + thisJoinPoint.toShortString() + " - " + r);
    }

}
