/*
 * Created on 08.01.2005
 *
 * $Id$
 */
package crypt;

import junit.framework.TestCase;

/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 08.01.2005
 * @version $revision$
 */
public class Rot13Test extends TestCase {

    public static void main(String[] args) {
        junit.textui.TestRunner.run(Rot13Test.class);
    }

    public final void testRot13() {
        Rot13 r = new Rot13("hello");
        assertEquals("uryyb", r.toString());
    }

    /**
     * Class under test for String crypt(String)
     */
    public final void testCryptString() {
        String s = Rot13.crypt("Hello");
        assertEquals("Uryyb", s);
    }
    
    /**
     * Dieses Beispiel stammt von de.wikipedia.org
     * @see http://de.wikipedia.org/wiki/ROT13
     */
    public final void testCryptSentence() {
        String s = Rot13
                .crypt("Dies ist ein Beispieltext, um ROT13 zu demonstrieren.");
        assertEquals("Qvrf vfg rva Orvfcvrygrkg, hz EBG13 mh qrzbafgevrera.", s);
    }
    
    /**
     * Test with uppercase letters only.
     */
    public final void testCryptUC() {
        String s = Rot13.crypt("HELLO");
        assertEquals("URYYB", s);
    }
    
    public final void testCryptDecrypt() {
        String s = Rot13.crypt("Hello");
        assertEquals("Hello", Rot13.decrypt(s));
        assertEquals("Hello", Rot13.crypt(s));
    }

}
