/*
 * Created on 05.01.2005
 *
 * $Id$
 */
package casino.player;

import casino.*;

/**
 * Die Strategie des DoubleBetPlayers ist es, nach jedem verlorenen Spiel
 * den Einsatz zu verdoppeln.
 * 
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 05.01.2005
 * @version $revision$
 */
public class DoubleBetPlayer extends Player {
    
    /** hab ich beim letzten Mal gewonnen? */
    private Einsatz gewinn = null;
    
    /** letzten Einsatz merken */
    private Einsatz einsatz = null;

    /**
     * @param name Spielername
     */
    public DoubleBetPlayer(String name) {
        super(name);
    }

    /**
     * @param name  Spielername
     * @param konto Startkapital
     */
    public DoubleBetPlayer(String name, Konto konto) {
        super(name, konto);
    }
    
    /**
     * Setzt 1 Chip auf PAIR. Nach jedem verlorenen Spiel wird dieser
     * Einsatz verdoppelt (bis max. 500 Chips)
     */
    public Einsatz getEinsatz() {
        if ((gewinn == null) || (gewinn.getPair() == 0)) {
            einsatz = doubleEinsatz();
        } else {
            einsatz = new Einsatz();
            einsatz.setPair(1);
        }
        super.setEinsatz(einsatz);
        return einsatz;
    }
    
    private Einsatz doubleEinsatz() {
        if (einsatz == null) {
            einsatz = new Einsatz();
            einsatz.setPair(1);
        } else {
            int betrag = einsatz.getPair() * 2;
            if (betrag > 500) {
                betrag = 500;
            }
            einsatz.setPair(betrag);
        }
        return einsatz;
    }
    
    /**
     * Gewinn merken fuer naechsten Einsatz und auf Konto verbuchen.
     * @see Player.setGewinn(Einsatz)
     */
    public void setGewinn(Einsatz gewinn) {
        super.setGewinn(gewinn);
        this.gewinn = gewinn;
    }

}
