/*
 * Created on 15.04.2005
 *
 * $Id$
 */
package pattern;

public aspect BugPattern {
    
    /**
     * In the project it not allowed to call a method with a null-parameter.
     */
    before() : (call(* *..*.*(*, ..)) || call(*..*.new(*, ..)))
               && !within(BugPattern) {
        checkArgs(thisJoinPoint.getArgs());
    }

    /**
     * In this project it is not allowed for a method to return "null"
     */
    after() returning(Object returned) :
            execution(Object+ *..*(..))
            && !within(BugPattern) {
        if (returned == null) {
            throw new NullPointerException(thisJoinPoint.getSignature() 
                    + " returns (null)!");
        }
    }
    
    /**
     * check arguemts -- if one of the arguments is null a NullPointerExcption
     * is thrown.
     */
    private void checkArgs(Object[] args) {
        for (int i = 0; i < args.length; i++) {
            if (args[i] == null) {
                throw new NullPointerException("oops - args" + i + " == null");
            }
        }
    }
    
}
