/*
 * Created on 03.01.2005
 *
 * $Id$
 */
package casino;

/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 03.01.2005
 * @version $revision$
 */
public aspect KontoAspect {
    
    /**
     * Vorbedingung fuer abheben(): genug Geld auf dem Konto
     */
    before(int betrag, Konto kto) :
            execution(public void Konto.abheben(int))
            && args(betrag)
            && this(kto) {
        if (betrag > kto.abfragen()) {
            throw new RuntimeException(
                    "Vorbedingung verletzt: zuwenig Geld auf Konto");
        }
    }
    
    /**
     * Vorbedingung fuer einzahlen() : positiver Betrag
     */
    before(int betrag) :
            execution(public void Konto.einzahlen(int))
            && args(betrag) {
        if (betrag < 0) {
            throw new RuntimeException(
                    "Vorbedingung verletzt: negativer Betrag");
        }
    }

    /**
     * Nachbedingung fuer abheben() und einzahlen(): 
     * Konto ist nicht im Minus
     */
    after(Konto kto) :
            (execution(public void Konto.abheben(int))
            || execution(public void Konto.einzahlen(int)))
            && this(kto) {
        if (kto.abfragen() < 0) {
            throw new RuntimeException(
                    "Nachbedingung verletzt: Konto im Minus");
        }
    }
    
}
